package jp.ac.takushoku_u.cs;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import java.util.Iterator;

/**
* MathEdgeNXEdgeSet̉ZpNXłB
* @version 1.0
* @author } Tj(Kasajima Hiroshi)
* @see jp.ac.takushoku_u.cs.Edge
* @see jp.ac.takushoku_u.cs.EdgeSet
*/
/*
* ŏIXV 2004N1208
*/
public final class MathEdge{
	
/**
* RXgN^
*/
	private MathEdge(){}
	
/**
* setAsetB̐ϏW(AND)Ԃ܂B
* @param setA ZEdgeSet
* @param setB ZEdgeSet
* @return 2̐ϏW
*/
	public static final EdgeSet getAndEdge(EdgeSet setA, EdgeSet setB){
		EdgeSet returnSet = new EdgeSet();
		
		Iterator i = setA.iterator();
    	while(i.hasNext()){
    		Edge ed = (Edge)i.next();
    		Iterator j = setB.iterator();
    		while(j.hasNext()){
    			Edge ef = (Edge)j.next();
    			if(ed.isSameEdge(ef)){
    				returnSet.add(new Edge(ed.getBegin(), ed.getEnd()));
    			}
    		}
    	}
		
		return returnSet;
	}
	
/**
* setAsetB̘aW(OR)Ԃ܂B
* @param setA ZEdgeSet
* @param setB ZEdgeSet
* @return 2̘aW
*/
	public static final EdgeSet getOrEdge(EdgeSet setA, EdgeSet setB){
		EdgeSet returnSet = new EdgeSet();
		
		Iterator i = setA.iterator();
    	while(i.hasNext()){
    		Edge ed = (Edge)i.next();
    		returnSet.add(new Edge(ed.getBegin(), ed.getEnd()));
    	}
    		
    	Iterator j = setB.iterator();
    	while(j.hasNext()){
    		Edge ef = (Edge)j.next();
    		returnSet.add(new Edge(ef.getBegin(), ef.getEnd()));
    	}
		
		return returnSet;
	}
	
/**
* setA܂setBꂩɂȂvf̏W(XOR)Ԃ܂B
* @param setA ZEdgeSet
* @param setB ZEdgeSet
* @return 2̔rI_ȁW
*/
	public static final EdgeSet getXOrEdge(EdgeSet setA, EdgeSet setB){
		EdgeSet returnSet = new EdgeSet();
		
		Iterator i = setA.iterator();
    	while(i.hasNext()){
    		Edge ed = (Edge)i.next();
    		
    		Iterator j = setB.iterator();
    		boolean flag = true;
    		while(j.hasNext()){
    			Edge ef = (Edge)j.next();
    			if(ed.isSameEdge(ef)){
    				flag = false;
    			}
    		}
    		if(flag){
    			returnSet.add(new Edge(ed.getBegin(), ed.getEnd()));
    		}
    	}
		
		i = setB.iterator();
    	while(i.hasNext()){
    		Edge ed = (Edge)i.next();
    		
    		Iterator j = setA.iterator();
    		boolean flag = true;
    		while(j.hasNext()){
    			Edge ef = (Edge)j.next();
    			if(ed.isSameEdge(ef)){
    				flag = false;
    			}
    		}
    		if(flag){
    			returnSet.add(new Edge(ed.getBegin(), ed.getEnd()));
    		}
    	}
		
		return returnSet;
	}
	
/**
* setAɂ݂Ȃvf̏W(W)Ԃ܂B
* @param setA ZEdgeSet
* @param setB ZEdgeSet
* @return setAɂ݂Ȃvf̏W
*/
	public static final EdgeSet getSubEdge(EdgeSet setA, EdgeSet setB){
		EdgeSet returnSet = new EdgeSet();
		
		Iterator i = setA.iterator();
    	while(i.hasNext()){
    		Edge ed = (Edge)i.next();
    		
    		Iterator j = setB.iterator();
    		boolean flag = true;
    		while(j.hasNext()){
    			Edge ef = (Edge)j.next();
    			if(ed.isSameEdge(ef)){
    				flag = false;
    			}
    		}
    		if(flag){
    			returnSet.add(new Edge(ed.getBegin(), ed.getEnd()));
    		}
    	}
		
		return returnSet;
	}
}